VERSION 5.00
Begin VB.UserControl dCDMenuList 
   Alignable       =   -1  'True
   AutoRedraw      =   -1  'True
   ClientHeight    =   1455
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   2040
   ScaleHeight     =   97
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   136
   Begin VB.PictureBox PicBase 
      AutoRedraw      =   -1  'True
      BackColor       =   &H00FFFFFF&
      BorderStyle     =   0  'None
      Height          =   825
      Left            =   0
      ScaleHeight     =   55
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   87
      TabIndex        =   0
      Top             =   0
      Width           =   1305
      Begin VB.PictureBox pIcon 
         AutoRedraw      =   -1  'True
         AutoSize        =   -1  'True
         BackColor       =   &H00FF00FF&
         BorderStyle     =   0  'None
         Height          =   480
         Left            =   540
         ScaleHeight     =   32
         ScaleMode       =   3  'Pixel
         ScaleWidth      =   32
         TabIndex        =   2
         Top             =   150
         Visible         =   0   'False
         Width           =   480
      End
      Begin VB.VScrollBar vBar 
         Height          =   540
         Left            =   210
         TabIndex        =   1
         Top             =   165
         Width           =   270
      End
   End
End
Attribute VB_Name = "dCDMenuList"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Declare Function FillRect Lib "user32" (ByVal hdc As Long, lpRect As RECT, ByVal hBrush As Long) As Long
Private Declare Function CreateSolidBrush Lib "gdi32.dll" (ByVal crColor As Long) As Long
Private Declare Function DeleteObject Lib "gdi32.dll" (ByVal hObject As Long) As Long
Private Declare Function DrawText Lib "user32.dll" Alias "DrawTextA" (ByVal hdc As Long, ByVal lpStr As String, ByVal nCount As Long, ByRef lpRect As RECT, ByVal wFormat As Long) As Long
Private Declare Function TransparentBlt Lib "msimg32.dll" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal nSrcWidth As Long, ByVal nSrcHeight As Long, ByVal crTransparent As Long) As Long
Private Declare Function SelectObject Lib "gdi32.dll" (ByVal hdc As Long, ByVal hObject As Long) As Long
Private Declare Function OleTranslateColor Lib "oleaut32.dll" (ByVal lOleColor As Long, ByVal lHPalette As Long, ByRef lColorRef As Long) As Long
Private Declare Function SetRect Lib "user32" (lpRect As RECT, ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long

Private Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type

Private Type Item
    iCaption As String
    iText As String
    iKey As String
    iImage As Variant
End Type

'Text Style Consts
Private Const DT_SINGLELINE As Long = &H20
Private Const DT_VCENTER As Long = &H4
'Item Max size
Private Const m_ItemSize = 40
'Item Width
Private m_ItemWidth As Long
'Item Count
Private m_ListCount As Long
'Holds the item data
Private m_ItemData() As Item
'Last visable Item index.
Private m_LastItem As Long
'Item Index
Private m_Index As Long

Private m_SelectBkColor As OLE_COLOR
Private m_SelectFColor As OLE_COLOR
Private m_ForeColor As OLE_COLOR

Private c_Rect As RECT

Private m_Button As MouseButtonConstants
'Event Declarations:
Event MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
Event DblClick()
Event Click()
Event MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
Event MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
Event Selected(ByVal Index As Long)
Event Change()

Private Sub PicBase_KeyUp(KeyCode As Integer, Shift As Integer)
    Select Case KeyCode
        Case vbKeyHome
            ListIndex = 1
        Case vbKeyEnd
            ListIndex = ListCount
        Case vbKeyDown, vbKeyRight
            If (ListIndex >= ListCount) Then Exit Sub
            ListIndex = ListIndex + 1
        Case vbKeyUp, vbKeyLeft
            If (ListIndex <= 1) Then Exit Sub
            ListIndex = ListIndex - 1
    End Select
    
End Sub

Private Sub PicBase_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
Dim Pre_Idx As Long
On Error Resume Next
    
    m_Button = Button
    'Check that the left button was pressed.
    If Button <> vbLeftButton Then Exit Sub
    'Get Prev item.
    Pre_Idx = ListIndex
    'Get Item Index
    ListIndex = ((Y \ m_ItemSize) + vBar.Value) + 1
    'Check that index is not greator than the count.
    If (ListIndex > ListCount) Then ListIndex = Pre_Idx
    'Render Items
    Call RenderLB
    RaiseEvent MouseDown(Button, Shift, X, Y)
End Sub

Private Sub PicBase_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent MouseMove(Button, Shift, X, Y)
End Sub

Private Sub PicBase_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent MouseUp(Button, Shift, X, Y)
End Sub

Private Sub PicBase_DblClick()
    If (m_Button = vbLeftButton) Then
        RaiseEvent DblClick
    End If
End Sub

Private Sub PicBase_Click()
    If (m_Button = vbLeftButton) Then
        RaiseEvent Click
        RaiseEvent Selected(ListIndex)
    End If
End Sub

Private Sub UserControl_InitProperties()
    SelectBackColor = vbBlue
    SelectForeColor = vbWhite
    ForeColor = vbBlack
End Sub

Private Sub UserControl_Resize()
    Call ResizeAll
End Sub

Private Sub UserControl_Show()
    UserControl_Resize
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    Call PropBag.WriteProperty("SelectBackColor", SelectBackColor, vbBlue)
    Call PropBag.WriteProperty("SelectForeColor", SelectForeColor, vbWhite)
    Call PropBag.WriteProperty("BackColor", PicBase.BackColor, &HFFFFFF)
    Call PropBag.WriteProperty("Enabled", UserControl.Enabled, True)
    Call PropBag.WriteProperty("MouseIcon", MouseIcon, Nothing)
    Call PropBag.WriteProperty("MousePointer", PicBase.MousePointer, 0)
    Call PropBag.WriteProperty("ForeColor", ForeColor, vbBlack)
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    SelectBackColor = PropBag.ReadProperty("SelectBackColor", vbBlue)
    SelectForeColor = PropBag.ReadProperty("SelectForeColor", vbWhite)
    PicBase.BackColor = PropBag.ReadProperty("BackColor", &HFFFFFF)
    UserControl.Enabled = PropBag.ReadProperty("Enabled", True)
    Set MouseIcon = PropBag.ReadProperty("MouseIcon", Nothing)
    PicBase.MousePointer = PropBag.ReadProperty("MousePointer", 0)
    ForeColor = PropBag.ReadProperty("ForeColor", vbBlack)
End Sub

Private Sub vBar_Change()
    RenderLB
End Sub

Private Sub vBar_GotFocus()
    PicBase.SetFocus
End Sub

Private Sub vBar_Scroll()
    Call vBar_Change
End Sub

'Control Properties stuff
Public Property Get ListCount() As Long
    ListCount = m_ListCount
End Property

Public Property Get ListIndex() As Long
    'Return ListItem Index
    ListIndex = m_Index
End Property

Public Property Let ListIndex(ByVal NewIndex As Long)
    m_Index = NewIndex
    Call RenderLB
    RaiseEvent Change
    PropertyChanged "ListIndex"
End Property

Public Property Get SelectBackColor() As OLE_COLOR
    SelectBackColor = m_SelectBkColor
End Property

Public Property Let SelectBackColor(ByVal NewColor As OLE_COLOR)
    m_SelectBkColor = NewColor
    Call RenderLB
    PropertyChanged "SelectBackColor"
End Property

Public Property Get SelectForeColor() As OLE_COLOR
    SelectForeColor = m_SelectFColor
End Property

Public Property Let SelectForeColor(ByVal NewColor As OLE_COLOR)
    m_SelectFColor = NewColor
    Call RenderLB
    PropertyChanged "SelectForeColor"
End Property

Public Property Get BackColor() As OLE_COLOR
    BackColor = PicBase.BackColor
End Property

Public Property Let BackColor(ByVal New_BackColor As OLE_COLOR)
    PicBase.BackColor() = New_BackColor
    PropertyChanged "BackColor"
End Property

Public Property Get Enabled() As Boolean
    Enabled = UserControl.Enabled
End Property

Public Property Let Enabled(ByVal New_Enabled As Boolean)
    UserControl.Enabled() = New_Enabled
    PropertyChanged "Enabled"
End Property

Public Property Get MouseIcon() As Picture
    Set MouseIcon = PicBase.MouseIcon
End Property

Public Property Set MouseIcon(ByVal New_MouseIcon As Picture)
    Set PicBase.MouseIcon = New_MouseIcon
    PropertyChanged "MouseIcon"
End Property

Public Property Get MousePointer() As MousePointerConstants
    MousePointer = PicBase.MousePointer
End Property

Public Property Let MousePointer(ByVal New_MousePointer As MousePointerConstants)
    PicBase.MousePointer() = New_MousePointer
    PropertyChanged "MousePointer"
End Property

Public Property Get ForeColor() As OLE_COLOR
    ForeColor = m_ForeColor
End Property

Public Property Let ForeColor(ByVal New_ForeColor As OLE_COLOR)
    m_ForeColor = New_ForeColor
    Call RenderLB
    PropertyChanged "ForeColor"
End Property

Public Sub Refresh()
    PicBase.Refresh
End Sub

Public Property Get ItemKey(Index As Long) As String
On Error Resume Next
    ItemKey = m_ItemData(Index).iKey
End Property

Public Property Let ItemKey(Index As Long, NewKey As String)
    m_ItemData(Index).iKey = NewKey
End Property

Public Property Get Caption(Index As Long) As String
On Error Resume Next
    Caption = m_ItemData(Index).iCaption
End Property

Public Property Let Caption(Index As Long, NewCaption As String)
    m_ItemData(Index).iCaption = NewCaption
End Property


'Public Listbox Subs
Public Sub AddItem(sCaption As String, sText As String, Key As Variant, nPicture)
    'INC Listcount
    m_ListCount = (m_ListCount + 1)
    'Resize array to hold items
    ReDim Preserve m_ItemData(ListCount)
    'Fill in Item Info
    With m_ItemData(ListCount)
        Set .iImage = nPicture
        .iCaption = sCaption
        .iText = sText
        .iKey = Key
    End With

    'Render the items
    Call RenderItem(ListCount)
End Sub

Public Sub Clear()
    PicBase.Cls
    m_ListCount = 0
    Erase m_ItemData
    Call RenderLB
    vBar.Visible = ListCount
End Sub

'Private Listbox Subs, Functions, Tools
Private Function SelectItem(ItemY As Long, hdc As Long, oColor As OLE_COLOR)
Dim hBrush As Long
    'Setup the rect
    SetRect c_Rect, 0, (ItemY + m_ItemSize) + 1, m_ItemWidth, ItemY + 1
    'Create the Brush
    hBrush = CreateSolidBrush(TranslateColor(oColor))
    'Fill selection area,
    FillRect e .eColoac_Rec FillRect e .eColoac_R'Fill selection area,
EIEect e .eColoac_R'Fill selection area,
E't MousEnd Su  'Create .iIm_) + 1oFillRect e .eColoac_Re
Ene
Enwn_Re
Ene
Enwn_Re
Ene
Enwnl
Enwn&Nata
    Call RenderLB
d  0derLne
Enwnl
Enwn&Nata
    Caloloac_Re
Ene
Enwn_Re
Ene1   ForeCXliCBc Proerty Lefe selection area,
E't Mo= (m_ListCopfreCXliCBc PEnwnl
EForeC_) + 1t e .ar.VisAs XliCBc Proerty Lefe selection areeEne
EnaroertEbe))))))))))))))roertEbe))))))))))))))roertEbe))))))))))))))roeerty Lefe selecEIEect Lefe selecEIEect Lefe selec))))))))))))))roeerty n area,
  ))rPoeert Sub

Prirnsh(TranslateColor(oColor))))roeo
End Proper)nslateColor(oColor))))roeo
Eyroperty

Public E ))ouseUp(ButtolsBash(Trmlic () = New_G(TrmlcEIEect Lefe sel   m_Index ert,Xoiing,sert,Xoiing,sert,Xy


'PublielatWith
b

Prirnsh(TranslateColor(oa,
Ecefe selecEIEecfe ) d=serConUfree  As RECT, ByVal wFormaVTranslateColor(oewColor As OLE_COLOR)BPlE_CForeC_) + 1t  ilc () = Ne)s
Private FunclatWith C

Public E ))ouseUp(ButublielatW b&tup t)))BwiFueLE_COLOR)BPt,_G(TrmlcEIublielatW bubl2e
End Property

Pubaty LePubaV)

Pubaty LePuarty

Pubaty LPubaty LePuarty

Pubataption = m_ItemData(InclatWith C

Public E ))ouseUp(ButublielatW b&oeeckColor() As O(F EChanged "ELePuatRbaty LPubaty LePE ))oP_    (Transli&oeeckcnclaanslielatW b&reColor
 (F EChanged "ELePuatRe.5oy(Index As Long) As String
On Error ByVal wFoeckcnclaanslielatW b&reColor
 (F EChangedolor
 (F ECibl2e
Cai_Rec FillRlorielatW bubl2i&oe
i
On ErrT .)Xion = sC C

PublieF EAbXy


Lai_RLk FillReoyxh C

PublivBar_ChangC

Pliv.BCT, ByVal Call RenderyaibgC

Pli nderyact Lef End If
End eate the Brnf Endefe slic E ))ouseUp(
Private Sub vroertEbeePuatRbaty LPubliCon = sC C

PublieF EAbXy
ePuatRe.5oy(Index As Long) As String
On  As Long) As.5oy(Index As Long)Y" = e
EnwkColor(Eged "ELePuatRe.5act Lef End If
EndAOn ErrT .)Xion  ByVal wForm.5oy(Inde Begin VB.e.5c.5oy(IndevivBnslIlhTDIy(I0AbXy
ePuatRe.5oy(Index As Long) As Stringoac_R'FidAOn ErrT ingoacai_nofong) AsResize arrivate Declare Functilclare FunctiD0AbXy
ePuatRe.5oy(Index)n"
AttributeIlhTDIytW bubl2e
nrT .)Xion As Stringoac_R'FidAOn ErrTPuaongew_BackColor
 Color
lic ProaibgC

Pli DeclarLong) As Long
PrivateBaIf
ni DeclarLou   SetRect c_Rect, 0Vdex >= ListCount) Then Exie
EnwkColor(Eged ">adPropertlornt) Then Exie
Enwk 1
    'CB.e.5c.5oyc.5oy(IndevivBnslaount) Thrt Enabled(Bsuntd))))rnt) The(
EndAOn ErrT,tndAOS

Pli DeclarLong) As Long
 ,s LoTblateColor(ctilclare FunctExie
EnwkCo(ctilwk 1
oie
Enwk 1
trT,tnde
EnvBar_CrLne
Enwnl
Enwnx2

Puor(ctilclareAbXy
ePr(ctilclareAbXy
ePr(ctilclareAbXy
ePr(ctDNeColor(ctilclare FunctEe, Y AsLVlare FunctEu   Sec .aiseEvenueclar


 lAs Long,  e .eCons Stringoac_R3n(ButublielatW b&oeecW + 1 b&eU